/* Compileraufruf fr DICE: "dcc Hybris.c -oHybris"

   Fehler:

   - 6er, 7er, ... fehlen total

   maybe to do (Schnheitskorrekturen mit Effekt):
   - nderung von Spalten-/Zeilenzahl/Fallverzgerung durch Joystick
     (siehe Probleme)

   Probleme:

   - Einstellungen mit Joystick:
     Der (noch in Kommentaren erhaltene) Versuch, die Hhe und Breite des
     Spielfeldes auch per Joystick zu steuern, fhrte aus ungeklrten
     Grnden dazu, da nach der ersten derartigen Aktion die Joystick-
     Steuerung blockiert war. Nach Drcken irgendeiner Taste (sogar <SHIFT>
     reichte) war der Joystick wieder frei.
   - Preview-Umschaltung whrend des Spiels fhrt zum Lschen der Grafik.
     Entweder, das wird gesperrt (z.Zt. der Fall), oder ich lasse die
     ungltige Grafik im Spiel stehen.
     Letzteres wre kein Problem, wenn man nicht auch das Preview
     ZUschalten und somit ein greres Window notwendig machen knnte. Ich
     sehe also im Moment nur die Mglichkeit, die Preview-Schaltung whrend
     des Spiels lahmzulegen.
     Eigentlich wre es wnschenswert, auch whrend des Spiels das Preview
     zu- und abschalten zu knnen.

/* Hybris.c */

/* Stellen, die bei Integration von 6ern und 7ern gendert werden mssen,
   sind (soweit erkannt) mit folgendem Kommentar versehen: */

/*67*/

/* nur 2.0-fhig ! */

#define MINROWS 4
#define MAXROWS 35
#define MINCOLS 3
#define MAXCOLS 30
#define MAXPARTS 7      /* ein Stein hat max. MAXPARTS 'Felder' */
#define STEINE 28       /* Anzahl verschiedener Steine */
#define MAXSTRESS 20    /* so stark knnen die einzelnen Gruppen maximal
                           bewertet werden */
#define BLOCKWIDTH 12   /* fr die Grafik-Dimensionen */
#define BLOCKHEIGHT 6
#define MOVEDELAY 8     /* nach jedem Zug wird um MOVEDELAY/50s pausiert, um
                           die Wiederholung zu verzgern */

#include <exec/types.h>
#include <exec/memory.h>
#include <exec/devices.h>
#include <devices/gameport.h>
#include <devices/inputevent.h>
#include <libraries/dos.h>
#include <libraries/gadtools.h>
#include <intuition/intuition.h>
/* Pseudo-IntuiMessage-Class fr Joystick-Bewegungen: */
#define IDCMP_JOY 0x01000000L
#include <intuition/gadgetclass.h>
#include <graphics/rastport.h>
#include <utility/tagitem.h>
#include <clib/exec_protos.h>
#include <clib/dos_protos.h>
#include <clib/intuition_protos.h>
#include <clib/gadtools_protos.h>
#include <clib/graphics_protos.h>
#include <clib/alib_protos.h>
#include <stdio.h>

/* Struktur, die einen (fallenden) Stein enthalten soll:
   Teile enthlt die Anzahl der NICHT-ZENTRALEN Teile; (0,0) = links oben
   Breite enthlt die Breite des Steines so, wie er beschrieben ist (und
   eingeworfen wird). Diese Breite dient mit der u.a. Konvention ber
   MitteX zum positionieren der Steine im Zwei-Spieler-Modus             */

struct Stein { BYTE Teile,MitteX,MitteY,Breite;
               BYTE OffsetX[MAXPARTS-1],OffsetY[MAXPARTS-1]; };

/* die Steine:
    - fr MitteY ist die Startposition beim Fallenlassen eingetragen
    - fr MitteX wird die Startposition beim Fallenlassen eingetragen
    Als zentraler Stein ist zu whlen:
    - bei geradzahliger Breite der Stein direkt links neben der Mitte
    - bei ungeradzahliger Breite der Stein in der Mitte
    (wird diese Regel durchbrochen, so kann bei lnglichen Steinen nicht
     garantiert werden, da sie beim Auftauchen berhaupt ins Spielfeld
     passen. Das wird aber erst akut, wenn der Stein zu einer Seite hin
     weiter hinausragt, als der "gerade" Stein mit <Breite> Elementen.)  */

struct Stein Steine[STEINE]={
    /*  0: #+## */  { 3,0,0,4, {-1,1,2,0,0,0},   {0,0,0,0,0,0} },

    /*  1: #+#
             #  */  { 3,0,0,3, {-1,1,1,0,0,0},   {0,0,1,0,0,0} },

    /*  2: #+#
            #   */  { 3,0,0,3, {-1,0,1,0,0,0},   {0,1,0,0,0,0} },

    /*  3: #+#
           #    */  { 3,0,0,3, {-1,-1,1,0,0,0},  {0,1,0,0,0,0} },

    /*  4: #+
            ##  */  { 3,0,0,3, {-1,0,1,0,0,0},   {0,1,1,0,0,0} },

    /*  5:  +#
           ##   */  { 3,0,0,3, {-1,0,1,0,0,0},   {1,1,0,0,0,0} },

    /*  6: +#
           ##   */  { 3,0,0,3, {0,1,1,0,0,0},    {1,0,1,0,0,0} },

    /*  7: +    */  { 0,0,0,1, {0,0,0,0,0,0},    {0,0,0,0,0,0} },

    /*  8: +#   */  { 1,0,0,2, {1,0,0,0,0,0},    {0,0,0,0,0,0} },

    /*  9: #+#  */  { 2,0,0,3, {-1,1,0,0,0,0},   {0,0,0,0,0,0} },

    /* 10: +#
           #    */  { 2,0,0,2, {1,0,0,0,0,0},    {0,1,0,0,0,0} },

    /* 11: ##+## */ { 4,0,0,5, {-2,-1,1,2,0,0},  {0,0,0,0,0,0} },

    /* 12: ##+#
              # */  { 4,0,0,5, {-2,-1,1,1,0,0},  {0,0,0,1,0,0} },

    /* 13: ##+#
             #  */  { 4,0,0,5, {-2,-1,1,0,0,0},  {0,0,0,1,0,0} },

    /* 14: #+##
            #   */  { 4,0,0,4, {-1,1,2,0,0,0},   {0,0,0,1,0,0} },

    /* 15: #+##
           #    */  { 4,0,0,4, {-1,1,2,-1,0,0},  {0,0,0,1,0,0} },

    /* 16: ##+
             ## */  { 4,0,0,5, {-2,-1,0,1,0,0},  {0,0,1,1,0,0} },

    /* 17: #+#
            ##  */  { 4,0,0,3, {-1,1,0,1,0,0},   {0,0,1,1,0,0} },

    /* 18: #+#
           # #  */  { 4,0,0,3, {-1,1,-1,1,0,0},  {0,0,1,1,0,0} },

    /* 19: #+#
           ##   */  { 4,0,0,3, {-1,1,-1,0,0,0},  {0,0,1,1,0,0} },

    /* 20:  #+#
           ##   */  { 4,0,0,5, {-1,1,-2,-1,0,0}, {0,0,1,1,0,0} },

    /* 21:  #+#
            #
            #   */  { 4,0,0,3, {-1,1,-1,-1,0,0}, {0,0,1,2,0,0} },

    /* 22: ###
            +
            #   */  { 4,0,1,3, {-1,0,1,0,0,0},   {-1,-1,-1,1,0,0} },

    /* 23:  #
           #+#
             #  */  { 4,0,1,3, {-1,0,1,1,0,0},   {0,-1,0,1,0,0} },

    /* 24: #
           #+#
             #  */  { 4,0,1,3, {-1,-1,1,1,0,0},  {0,-1,0,1,0,0} },

    /* 25:  #
           #+#
           #    */  { 4,0,1,3, {-1,0,1,-1,0,0},  {0,-1,0,1,0,0} },

    /* 26:   #
           #+#
           #    */  { 4,0,1,3, {-1,-1,1,1,0,0},  {0,1,0,-1,0,0} },

    /* 27:  #
           #+#
            #   */  { 4,0,1,3, {-1,0,0,1,0,0},   {0,-1,1,0,0,0} }
    };

/* Zuordnung der verschiedenen Steinen zu Anzahl-Gruppen: */
struct AGruppe { short von, bis; };

struct AGruppe Gruppen[8]= { {-1,0},  {7,7},   {8,8},   {9,10},
                             {0,6},   {11,27}, {-1,0},  {-1,0}  };

/* Array mit den gegenwrtig erlaubten Stein-Nummern: */
short                   erlaubte_steine[STEINE*MAXSTRESS],
                        anzahl_erlaubter_steine;

/* Array mit den gegenwrtigen 'Betonungen' der Stein-Gruppen: */
BYTE                    betonungen[8];

extern struct Library   *IntuitionBase; /* fr Kickstart-Test */
struct Library          *GadToolsBase=NULL;  /* damit unter 1.3 auch ein
                                                Fehler zustandekommt */
struct Gadget           *GadgetList=NULL,*Gadgets[13];
struct VisualInfo       *VInfo=NULL;
struct Window           *window=NULL,*setupwindow=NULL,*pausewindow=NULL;
struct RastPort         *RP;
struct TextAttr         generalFont={(STRPTR)"topaz.font",TOPAZ_SIXTY,
                                    FS_NORMAL,FPF_ROMFONT};
struct TextFont         *genFont=NULL;
struct IOStdReq         *game_io_msg=NULL;
struct InputEvent       gamebuffer;
struct MsgPort          *game_msg_port=NULL;
BOOL                    gameport_open=FALSE,controller_type_set=FALSE,
                        spiel_laeuft,zwei_spieler,collided[2],start,abort,
                        preview;
BYTE                    Spielfeld[MAXCOLS][MAXROWS],
                        Steine_Pro_Zeile[MAXROWS],FallDelay,rows,cols;
short                   abgesetzte_steine[2],abgesenkte_zeilen,y_zeilen,
                        y_preview;
struct Stein            aktueller_stein[2],naechster_stein[2];

static struct TagItem TAGA_DISABLE[]={ {GA_Disabled,TRUE}, {TAG_END,0} },
                      TAGA_ENABLE[]={ {GA_Disabled,FALSE}, {TAG_END,0} };

int set_controller_type(short type)   /* aus joystick.c, Fish #5 */
{
    char tmp;

    game_io_msg->io_Command = GPD_SETCTYPE;
                /* set type of controller to mouse */
    game_io_msg->io_Length = 1;
    game_io_msg->io_Data = (APTR) &tmp;
    tmp = type;

    DoIO(game_io_msg);
    GetMsg(game_msg_port);
    return((int)game_io_msg->io_Error);
}

VOID ScratchMsgQueue(struct MsgPort *port)
{ /* alle anliegenden Messages beantworten */
    struct Message *msg;

    while(msg=GetMsg(port)) ReplyMsg(msg);
}

VOID error(char *str)
{
    BYTE AlertText[300];

    if(str)
        {
        AlertText[0]=0; AlertText[1]=100; AlertText[2]=20;
        sprintf(&AlertText[3],"Hybris meldet Fehler: %s",str);
        DisplayAlert(RECOVERY_ALERT,AlertText,38);
        }
    if(genFont)                 CloseFont(genFont);
    if(window)
        {
        Forbid();
        ScratchMsgQueue(window->UserPort);
        CloseWindow(window);
        Permit();
        }
    if(setupwindow)
        {
        Forbid();
        ScratchMsgQueue(setupwindow->UserPort);
        CloseWindow(setupwindow);
        Permit();
        }
    if(pausewindow)
        {
        Forbid();
        ScratchMsgQueue(pausewindow->UserPort);
        CloseWindow(pausewindow);
        Permit();
        }
    if(VInfo)                   FreeVisualInfo(VInfo);
    if(controller_type_set)
        {
        if(!CheckIO(game_io_msg))       /* see if gameport read      */
            AbortIO(game_io_msg);       /*   anything; Abort, if not */
        WaitPort(game_msg_port);        /* wait for abort to complete */
        GetMsg(game_msg_port);          /* and strip message from port */
        set_controller_type(GPCT_NOCONTROLLER);
        }
    if(gameport_open)           CloseDevice(game_io_msg);
    if(game_msg_port)           DeletePort(game_msg_port);
    if(game_io_msg)             DeleteStdIO(game_io_msg);
    if(GadToolsBase)
        {
        FreeGadgets(GadgetList);
        CloseLibrary(GadToolsBase);
        }
    if(str)     exit(RETURN_ERROR);
    else        exit(RETURN_OK);
}

void Box1(WORD mode, WORD x0, WORD y0, WORD x1, WORD y1)
{   /* 2.0-like Kasten auerhalb des angegebenen Rechtecks zeichnen */

    SetAPen(RP,mode ? 2 : 1);
    Move(RP,x0-3,y1+2); Draw(RP,x1+3,y1+2); Draw(RP,x1+3,y0-2);
    Move(RP,x1+2,y1+1); Draw(RP,x1+2,y0-1);
    SetAPen(RP,mode ? 1 : 2);
    Move(RP,x0-3,y1+2); Draw(RP,x0-3,y0-2); Draw(RP,x1+2,y0-2);
    Move(RP,x0-2,y1+1); Draw(RP,x0-2,y0-1);
}

void Box2(WORD mode, WORD x0, WORD y0, WORD x1, WORD y1)
{   /* 2.0-like Kasten innerhalb des angegebenen Rechtecks zeichnen */

    SetAPen(RP,mode ? 2 : 1);
    Move(RP,x0,y1);     Draw(RP,x1,y1);     Draw(RP,x1,y0);
    Move(RP,x1-1,y1-1); Draw(RP,x1-1,y0+1);
    SetAPen(RP,mode ? 1 : 2);
    Move(RP,x0,y1);     Draw(RP,x0,y0);     Draw(RP,x1-1,y0);
    Move(RP,x0+1,y1-1); Draw(RP,x0+1,y0+1);
}

VOID ClearGamblingArea()
{   /* Spielfeld grafisch lschen */
    short x,y;

#define OX (BLOCKWIDTH/2-1)
#define OY1 (BLOCKHEIGHT/2-2)
#define OY2 (OY1+3)

    SetAPen(RP,0);
    RectFill(RP,5,3,5+cols*BLOCKWIDTH,3+rows*BLOCKHEIGHT);
    SetAPen(RP,1);
    for(x=0;x<cols;++x)
        for(y=0;y<rows;++y)
            {
            WritePixel(RP,5+OX+BLOCKWIDTH*x,3+OY1+BLOCKHEIGHT*y);
            WritePixel(RP,5+OX+BLOCKWIDTH*x,3+OY2+BLOCKHEIGHT*y);
            }
}

VOID Print(char *text, SHORT xpos, SHORT ypos)
{/* Ausgabe eines Textes */
    Move(RP,xpos,ypos+RP->TxBaseline);
    Text(RP,(UBYTE *)text,strlen(text));
}

VOID Scoring()
{ /* Einblenden, wieviele Zeilen / Steine bereits gespielt */
    char buffer[10];
    static short old_s1=-1,old_s2=-1,old_z=-1;

    SetAPen(RP,1);
    SetBPen(RP,0);
    SetDrMd(RP,JAM2);
    if(old_s1!=abgesetzte_steine[0])
        {
        sprintf(buffer,"%5d",old_s1=abgesetzte_steine[0]);
        Print(buffer,16+cols*BLOCKWIDTH,7+RP->TxHeight);
        }
    if((old_s2!=abgesetzte_steine[1])&&zwei_spieler)
        {
        sprintf(buffer,"%5d",old_s2=abgesetzte_steine[1]);
        Print(buffer,16+cols*BLOCKWIDTH,16+3*RP->TxHeight);
        }
    if(old_z!=abgesenkte_zeilen)
        {
        sprintf(buffer,"%5d",old_z=abgesenkte_zeilen);
        Print(buffer,16+cols*BLOCKWIDTH,y_zeilen);
        }
    SetDrMd(RP,JAM1);
}

struct Gadget *InitGads(struct VisualInfo *vi, struct NewWindow *nw)
{
#define NIL ((void *)0L)
    static struct NewGadget GadgetArray[]={
            {82,14,200,10,"Spalten",NIL,0,PLACETEXT_LEFT,NIL},
            {82,2,200,10,"Zeilen ",NIL,1,PLACETEXT_LEFT,NIL},
            {162,26,130,10,"Fallverzgerung",NIL,2,PLACETEXT_LEFT,NIL},
            {102,38,92,12,"_# Spieler",NIL,3,PLACETEXT_LEFT,NIL},
            {4,122,304,20,"Spiel _starten",NIL,4,PLACETEXT_IN,NIL}, /*67*/ /* {4,146,... */
            {42,62,240,10,"1er",NIL,17,PLACETEXT_LEFT,NIL},
            {42,74,240,10,"2er",NIL,18,PLACETEXT_LEFT,NIL},
            {42,86,240,10,"3er",NIL,19,PLACETEXT_LEFT,NIL},
            {42,98,240,10,"4er",NIL,20,PLACETEXT_LEFT,NIL},
            {42,110,240,10,"5er",NIL,21,PLACETEXT_LEFT,NIL},
            {42,122,240,10,"6er",NIL,22,PLACETEXT_LEFT,NIL},
            {42,134,240,10,"7er",NIL,23,PLACETEXT_LEFT,NIL},
            {282,38,12,12,"_Preview",NIL,5,PLACETEXT_LEFT,NIL}
            };
    static char *CycleArray_1[]={"1","2",(char *)NULL};
    struct Gadget *gad;
    struct NewGadget *ngad;
    short i;
    static struct TagItem TAGA_1[]={ {GTSL_Level,11},   {GTSL_Min,MINCOLS},
                                     {GTSL_Max,MAXCOLS},
                                     {GTSL_MaxLevelLen,3},
                                     {GTSL_LevelFormat,(STRPTR)"%2ld"},
                                     {GA_RelVerify,TRUE},
                                     {GTSL_LevelPlace,PLACETEXT_RIGHT},
                                     {TAG_END,0} },
                          TAGA_2[]={ {GTSL_Min,1},   {GTSL_Max,9},
                                     {GTSL_Level,0}, {GTSL_MaxLevelLen,2},
                                     {GTSL_LevelFormat,(STRPTR)"%ld"},
                                     {GA_RelVerify,TRUE},
                                     {GTSL_LevelPlace,PLACETEXT_RIGHT},
                                     {TAG_END,0} },
                          TAGA_3[]={ {GTCY_Labels,CycleArray_1},
                                     {GT_Underscore,'_'},    {TAG_END,0} };

    for(i=0,ngad=GadgetArray;i<sizeof(GadgetArray)/sizeof(struct NewGadget);
            ++i,++ngad)
        {
        ngad->ng_VisualInfo=vi;
        ngad->ng_TextAttr=&generalFont;
        }
    gad=CreateContext(&GadgetList);
    if(gad==NULL)   return((struct Gadget *)NULL);
    nw->FirstGadget=gad;
    gad=CreateGadgetA(SLIDER_KIND,gad,GadgetArray,TAGA_1);
    if(gad==NULL)   return((struct Gadget *)NULL);
    Gadgets[0]=gad;
    TAGA_1[0].ti_Data=20;
    TAGA_1[1].ti_Data=MINROWS;
    TAGA_1[2].ti_Data=MAXROWS;
    gad=CreateGadgetA(SLIDER_KIND,gad,GadgetArray+1,TAGA_1);
    if(gad==NULL)   return((struct Gadget *)NULL);
    Gadgets[1]=gad;
    TAGA_2[2].ti_Data=FallDelay;
    gad=CreateGadgetA(SLIDER_KIND,gad,GadgetArray+2,TAGA_2);
    if(gad==NULL)   return((struct Gadget *)NULL);
    Gadgets[2]=gad;
    gad=CreateGadgetA(CYCLE_KIND,gad,GadgetArray+3,TAGA_3);
    if(gad==NULL)   return((struct Gadget *)NULL);
    Gadgets[3]=gad;
    gad=CreateGadgetA(BUTTON_KIND,gad,GadgetArray+4,TAGA_3+1);
    if(gad==NULL)   return((struct Gadget *)NULL);
    Gadgets[4]=gad;
    TAGA_1[1].ti_Data=0;
    TAGA_1[2].ti_Data=MAXSTRESS;
    gad=CreateGadgetA(SLIDER_KIND,gad,GadgetArray+5,TAGA_1+1);
    if(gad==NULL)   return((struct Gadget *)NULL);
    Gadgets[5]=gad;
    gad=CreateGadgetA(SLIDER_KIND,gad,GadgetArray+6,TAGA_1+1);
    if(gad==NULL)   return((struct Gadget *)NULL);
    Gadgets[6]=gad;
    gad=CreateGadgetA(SLIDER_KIND,gad,GadgetArray+7,TAGA_1+1);
    if(gad==NULL)   return((struct Gadget *)NULL);
    Gadgets[7]=gad;
    gad=CreateGadgetA(SLIDER_KIND,gad,GadgetArray+8,TAGA_1+1);
    if(gad==NULL)   return((struct Gadget *)NULL);
    Gadgets[8]=gad;
    gad=CreateGadgetA(SLIDER_KIND,gad,GadgetArray+9,TAGA_1+1);
    if(gad==NULL)   return((struct Gadget *)NULL);
    Gadgets[9]=gad;
    /* TAGA_1[0].ti_Tag=GA_Disabled; */  /*67*/ /* entfllt / wird bei teilweiser Implementation relevant */
    /* TAGA_1[0].ti_Data=TRUE; */        /*67*/ /* dto */
    /*67*/ /* folgende Kommentarzeilen werden bei Implementation der 6er/7er gltig: */
    /*67*/ /* gad=CreateGadgetA(SLIDER_KIND,gad,GadgetArray+10,TAGA_1+1); */
    /*67*/ /* if(gad==NULL)   return((struct Gadget *)NULL); */
    /*67*/ /* Gadgets[10]=gad; */
    /*67*/ /* gad=CreateGadgetA(SLIDER_KIND,gad,GadgetArray+11,TAGA_1+1); */
    /*67*/ /* if(gad==NULL)   return((struct Gadget *)NULL); */
    /*67*/ /* Gadgets[11]=gad; */
    gad=CreateGadgetA(CHECKBOX_KIND,gad,GadgetArray+12,TAGA_3+1);
    if(gad==NULL)   return((struct Gadget *)NULL);
    Gadgets[12]=gad;
    return(GadgetList);
}

VOID ZeichneSteinchenRoh(BYTE farbe, short x, short y)
{ /* ein einzelnes Feld bei Grafik-Koordinaten x/y [linke obere Ecke]
     zeichnen */
  /* farbe: 0 - leer, 1 & 2: Kstchen, 1: blaues Kstchen */

    if(farbe)
        {
        Box2(FALSE,x,y,x+BLOCKWIDTH-1,y+BLOCKHEIGHT-1);
        SetAPen(RP,(farbe==1) ? 3 : 0);
        RectFill(RP,2+x,1+y,x+BLOCKWIDTH-3,y+BLOCKHEIGHT-2);
        }
    else{
        SetAPen(RP,0);
        RectFill(RP,x,y,x+BLOCKWIDTH-1,y+BLOCKHEIGHT-1);
        SetAPen(RP,1);
        WritePixel(RP,OX+x,OY1+y);
        WritePixel(RP,OX+x,OY2+y);
        }
}

VOID ZeichneSteinchen(BYTE farbe, BYTE x, BYTE y)
{ /* ein einzelnes Feld bei Feld-Koordinaten x/y zeichnen */
  /* farbe: 0 - leer, 1 & 2: Kstchen, 1: blaues Kstchen */

    ZeichneSteinchenRoh(farbe,5+x*BLOCKWIDTH,3+y*BLOCKHEIGHT);
}

VOID ZeichneStein(struct Stein *stein, BYTE farbe)
{ /* kompletten Spielstein zeichnen */
  /* farbe: 0 - leer, 1: blau, 2:grau */
    BYTE cnt,x,y;

    ZeichneSteinchen(farbe,x=stein->MitteX,y=stein->MitteY);
    for(cnt=0;cnt<stein->Teile;++cnt)
        ZeichneSteinchen(farbe,x+stein->OffsetX[cnt],y+stein->OffsetY[cnt]);
}

VOID Preview(BYTE spieler)
{ /* den naechsten_stein des angegebenen Spielers neu auslosen und ggf.
     einblenden */
    short x,y,cnt;
    struct Stein *stein;

    if(anzahl_erlaubter_steine==0)  return;
    stein=naechster_stein+spieler;
    *stein=Steine[erlaubte_steine[
                                RangeRand(anzahl_erlaubter_steine) ] ];
    /* Grafik-Koordinaten fr Preview: */
    x=16+cols*BLOCKWIDTH+RP->TxWidth*6-BLOCKWIDTH/2+
        (stein->MitteX-(cols-1)/2)*BLOCKWIDTH;
    /* Korrektur der Startposition bei Zwei-Spieler-Modus: */
    if(zwei_spieler)
        {
        if(spieler)     stein->MitteX+=(stein->Breite+1)/2;
        else            stein->MitteX-=stein->Breite/2+1;
        }
    if(!preview)        return;

    /* eigentliche Einblendung */
    y=y_preview+spieler*((MAXPARTS+3)/2)*BLOCKHEIGHT;
    SetAPen(RP,0);
    RectFill(RP,x-((MAXPARTS-1)/2)*BLOCKWIDTH,  y,
                x+((MAXPARTS+1)/2)*BLOCKWIDTH-1,
                y+((MAXPARTS+1)/2)*BLOCKHEIGHT-1);
    y+=stein->MitteY*BLOCKHEIGHT;
    ZeichneSteinchenRoh(spieler+1,x,y);
    for(cnt=0;cnt<stein->Teile;++cnt)
        ZeichneSteinchenRoh(spieler+1,x+stein->OffsetX[cnt]*BLOCKWIDTH,
                                      y+stein->OffsetY[cnt]*BLOCKHEIGHT);
}

VOID init_window()
{ /* die grafischen Elemente des Windows (neu) aufbauen */
    short cnt;

    SetRast(RP,0);
    SetDrMd(RP,JAM1);
    Box1(TRUE,5,3,4+cols*BLOCKWIDTH,2+rows*BLOCKHEIGHT);
    Box1(FALSE,14+cols*BLOCKWIDTH,3,
               15+cols*BLOCKWIDTH+12*RP->TxWidth,2+2*(RP->TxHeight+2));
    if(zwei_spieler)
        {
        Box1(FALSE,14+cols*BLOCKWIDTH,8+2*(RP->TxHeight+2),
                   15+cols*BLOCKWIDTH+12*RP->TxWidth,7+4*(RP->TxHeight+2));
        }
    y_zeilen=8+(2+3*zwei_spieler)*RP->TxHeight;
    Box1(FALSE,14+cols*BLOCKWIDTH,y_zeilen+4,
               15+cols*BLOCKWIDTH+12*RP->TxWidth,y_zeilen+5+RP->TxHeight);
    y_preview=y_zeilen+RP->TxHeight+7;
    if(preview)
        Box1(FALSE,14+cols*BLOCKWIDTH,y_preview+4,
                   15+cols*BLOCKWIDTH+12*RP->TxWidth,
                   y_preview+9+RP->TxHeight+(4+5*zwei_spieler)*BLOCKHEIGHT);
    SetAPen(RP,1);
    Print("Spieler 1:",16+cols*BLOCKWIDTH+RP->TxWidth,5);
    Print("Steine",16+cols*BLOCKWIDTH+6*RP->TxWidth,7+RP->TxHeight);
    if(zwei_spieler)
        {
        Print("Spieler 2:",16+cols*BLOCKWIDTH+RP->TxWidth,14+2*RP->TxHeight);
        Print("Steine",16+cols*BLOCKWIDTH+6*RP->TxWidth,16+3*RP->TxHeight);
        }
    y_zeilen+=RP->TxBaseline;
    Print("Zeilen",16+cols*BLOCKWIDTH+6*RP->TxWidth,y_zeilen);
    if(preview)
        {
        Print(zwei_spieler ? "Nchste:" : "Nchster:",
              16+cols*BLOCKWIDTH+RP->TxWidth/2+((1+zwei_spieler)*RP->TxWidth)/2,
              y_preview+RP->TxBaseline);
        y_preview+=RP->TxHeight+8;
        Preview(0);
        if(zwei_spieler)    Preview(1);
        }
    ClearGamblingArea();
}

VOID ResizeWindow();

VOID init()
{
#define IDCMP_KEYS IDCMP_VANILLAKEY|IDCMP_RAWKEY
#define STD_WFLGS WFLG_GIMMEZEROZERO|WFLG_RMBTRAP|WFLG_DRAGBAR|WFLG_DEPTHGADGET
    static struct NewWindow pwin={5,12,0,0,-1,-1,
                                IDCMP_KEYS|IDCMP_CHANGEWINDOW|IDCMP_INTUITICKS,
                                STD_WFLGS|WFLG_SMART_REFRESH,
                                NULL,NULL,(UBYTE *)"Hybris V1.3 - Game",
                                NULL,NULL,5,5,640,256,WBENCHSCREEN},
                            swin={310,12,320,157,-1,-1, /*67*/ /* ...,320,181,-1,... */
                                IDCMP_KEYS|SLIDERIDCMP|BUTTONIDCMP|IDCMP_CLOSEWINDOW|IDCMP_REFRESHWINDOW,
                                STD_WFLGS|WFLG_SIMPLE_REFRESH|WFLG_CLOSEGADGET,
                                NULL,NULL,(UBYTE *)"Hybris V1.3 - Setup",
                                NULL,NULL,5,5,640,256,WBENCHSCREEN};

    struct GamePortTrigger gpt;
    extern ULONG RangeSeed;
    struct Screen *wbscreen;
    short cnt;

    if(IntuitionBase->lib_Version<36) error("Kickstart 2.0 erforderlich");
    CurrentTime(&RangeSeed,&RangeSeed);
    if(!(GadToolsBase=OpenLibrary("gadtools.library",36)))
        error("gadtools.library V36+ erforderlich");

    /* Vorbereitung der GamePort-Abfrage */
    if(!(game_msg_port=CreatePort(NULL,0)))
        error("CreatePort() fehlgeschlagen");
    if(!(game_io_msg=CreateStdIO(game_msg_port)))
        error("CreateStdIO() fehlgeschlagen");
    if(OpenDevice("gameport.device",1,game_io_msg,0))
        error("gameport.device lt sich nicht ffnen");
    gameport_open=TRUE;
    if(set_controller_type(GPCT_ABSJOYSTICK))   /* Abfragemodus bestimmen */
        error("Probleme mit GPCT_ABSJOYSTICK");
    controller_type_set=TRUE;
    game_io_msg->io_Command=GPD_SETTRIGGER;     /* Abfragemodus, 2. Teil ? */
    game_io_msg->io_Length=sizeof(gpt);
    game_io_msg->io_Data=(APTR)&gpt;
    gpt.gpt_Keys=GPTF_UPKEYS+GPTF_DOWNKEYS;
    gpt.gpt_Timeout=MOVEDELAY;
    gpt.gpt_XDelta=gpt.gpt_YDelta=1;
    if(DoIO(game_io_msg))       error("Probleme mit GPD_SETTRIGGER");
    game_io_msg->io_Command = GPD_READEVENT;    /* ab jetzt nur noch abfragen */
    game_io_msg->io_Data = (APTR)&gamebuffer;
        /* into the input buffer, one at a time. */
        /* read-event waits for the preset conditions */
    game_io_msg->io_Length = sizeof(struct InputEvent);
        /* read one event each time we go back to the gameport */
    game_io_msg->io_Flags = 0;  /* dont use quick io */
    game_io_msg->io_Length = sizeof(struct InputEvent);
        /* jeweils EIN Event lesen */
    SendIO(game_io_msg);        /* Anfrage starten */

    /* Aufbau des Setup-Windows */
    if(!(wbscreen=LockPubScreen(NULL))) error("Kein PubScreen verfgbar !");
    if(!(VInfo=GetVisualInfo(wbscreen,TAG_END)))
        error("VisualInfo nicht verfgbar");
    if(!(genFont=OpenFont(&generalFont)))
        error("Font topaz/9 lt sich nicht ffnen !");
    if(!(InitGads(VInfo,&swin)))        error("Gadgets nicht verfgbar");
    swin.Screen=wbscreen;
    if(!(setupwindow=OpenWindowTags(&swin,WA_InnerWidth,(ULONG)312,
                                    WA_InnerHeight,(ULONG)144,TAG_END)))
        error("Setup-Window lt sich nicht ffnen");
    SetFont(setupwindow->RPort,genFont);
    GT_RefreshWindow(setupwindow,NULL);

    /* Aufbau des Spiel-Windows */
    pwin.Width=21+cols*BLOCKWIDTH+12*genFont->tf_XSize;
    pwin.Height=6+rows*BLOCKHEIGHT;
    pwin.Screen=wbscreen;
    if(!(window=OpenWindowTags(&pwin,WA_InnerWidth,(ULONG)pwin.Width,
                               WA_InnerHeight,(ULONG)pwin.Height)))
        error("Spiel-Window lt sich nicht ffnen");
    UnlockPubScreen(NULL,wbscreen);
    RP=window->RPort;
    SetFont(RP,genFont);
    /* Spiel-Window aufbauen */
    ResizeWindow();
}

VOID wechsle_betonung(BYTE nr, BYTE betonung)
{ /* wechselt fr die (nr)er-Steine des Erlaubtheits-Status und setzt dem-
     entsprechend Spielsart als erlaubt / verboten. Das Gadget selbst wird
     nicht aktualisiert */

    short cnt1,cnt2,cnt3;

    /* geht das berhaupt ? */
    if(betonung>0)  /* Betonung 0 geht immer */
        if((nr+(1+nr)*zwei_spieler)>cols)
            return; /* geht nicht */
    /* Abzhlen, wieviele Stein-Gruppen noch erlaubt sind: */
    for(cnt1=1,cnt3=0;cnt1<8;++cnt1)
        cnt3+=(betonungen[cnt1]>0);
    /* wenn 1. das Spiel luft und 2. die letzte erlaubte Gruppe gesperrt
       werden soll: Gadget-Anwahl zurcknehmen und keine weitere Aktion */
    if(spiel_laeuft && (cnt3==1) && (betonungen[nr]>0) && (betonung==0) )
        {
        GT_SetGadgetAttrs(Gadgets[nr+4],setupwindow,NULL,
                          GTSL_Level,betonungen[nr],TAG_END);
        return;
        }
    betonungen[nr]=betonung;
    GT_SetGadgetAttrs(Gadgets[nr+4],setupwindow,NULL,GTSL_Level,betonung,
                      TAG_END);
    /* Liste aller erlaubten Steine vorbereiten: */
    anzahl_erlaubter_steine=0;
    for(cnt1=1;cnt1<8;++cnt1)
        for(cnt2=0;cnt2<betonungen[cnt1];++cnt2)
            if(Gruppen[cnt1].von>=0)
                /* Steine mit <cnt1> Elementen einreihen */
                for(cnt3=Gruppen[cnt1].von;cnt3<=Gruppen[cnt1].bis;++cnt3)
                    erlaubte_steine[anzahl_erlaubter_steine++]=cnt3;
    if(!spiel_laeuft)
        GT_SetGadgetAttrs(Gadgets[4],setupwindow,NULL,GA_Disabled,
                          anzahl_erlaubter_steine==0,TAG_END);
    /* neue Steine neu auslosen */
    Preview(0);
    if(zwei_spieler)    Preview(1);
}

struct IntuiMessage *WaitMessage();

VOID ResizeWindow()
{ /* Die Spiel-Window-Gre den aktuellen Bedrfnissen (Zeilen, Spalten,
    Spielerzahl, Preview) anpassen */

    short width,height1,height2;

    width=21+cols*BLOCKWIDTH+12*genFont->tf_XSize;
    height1=6+rows*BLOCKHEIGHT;
    height2=26+genFont->tf_YSize*(2+3*zwei_spieler)+
            (11+RP->TxHeight+
             ((MAXPARTS+1)/2*(1+zwei_spieler)+zwei_spieler)*BLOCKHEIGHT) *
            preview;
    if(height2>height1) height1=height2;
    if((window->Width!=width)||(window->Height!=height1));
        {
        ChangeWindowBox(window,window->LeftEdge,window->TopEdge,
                        width+window->BorderRight+window->BorderLeft,
                        height1+window->BorderTop+window->BorderBottom);
        while(WaitMessage()->Class!=IDCMP_CHANGEWINDOW);
        }
    /* die Start-X-Positionen dem gegebenen Spielfeld anpassen */
    for(width=0;width<STEINE;++width) Steine[width].MitteX=(cols-1)/2;
    init_window();

    /* die einzelnen Spielstein-Gruppen gem Spielfeldbreite
       (erlauben) / (verbieten und mit 0 'betonen')             */
    for(width=2;width<=MAXPARTS-2;++width)  /*67*/ /*width<=MAXPARTS*/
        {
        if((width+(1+width)*zwei_spieler)>cols)
            { /* geht nicht */
            wechsle_betonung(width,0);
            GT_SetGadgetAttrs(Gadgets[width+4],setupwindow,NULL,
                              GTSL_Level,0,GA_Disabled,TRUE,TAG_END);
            }
        else /* geht */
            GT_SetGadgetAttrsA(Gadgets[width+4],setupwindow,NULL,TAGA_ENABLE);
        }
}

VOID Inc_FallDelay()
{ /* erhht (wenn mglich) die Fallverzgerung um eins */
    if(FallDelay==9)    return;
    GT_SetGadgetAttrs(Gadgets[2],setupwindow,NULL,GTSL_Level,++FallDelay,
                      TAG_END);
}

VOID Dec_FallDelay()
{ /* erniedrigt (wenn mglich) die Fallverzgerung um eins */
    if(FallDelay==1)    return;
    GT_SetGadgetAttrs(Gadgets[2],setupwindow,NULL,GTSL_Level,--FallDelay,
                      TAG_END);
}

VOID Inc_Spalten()
{ /* erhht (wenn mglich) die Spaltenzahl um eins */
    if(cols==MAXCOLS)   return;
    GT_SetGadgetAttrs(Gadgets[0],setupwindow,NULL,GTSL_Level,++cols,
                      TAG_END);
    ResizeWindow();
}

VOID Dec_Spalten()
{ /* erniedrigt (wenn mglich) die Spaltenzahl um eins */
    if(cols==MINCOLS)   return;
    GT_SetGadgetAttrs(Gadgets[0],setupwindow,NULL,GTSL_Level,--cols,
                      TAG_END);
    ResizeWindow();
}

VOID Inc_Zeilen()
{ /* erhht (wenn mglich) die Zeilenzahl um eins */
    if(rows==MAXROWS)   return;
    GT_SetGadgetAttrs(Gadgets[1],setupwindow,NULL,GTSL_Level,++rows,
                      TAG_END);
    ResizeWindow();
}

VOID Dec_Zeilen()
{ /* erniedrigt (wenn mglich) die Zeilenzahl um eins */
    if(rows==MINROWS)   return;
    GT_SetGadgetAttrs(Gadgets[1],setupwindow,NULL,GTSL_Level,--rows,
                      TAG_END);
    ResizeWindow();
}

struct IntuiMessage *GetMessage(struct Window *wd)
{/* MsgPort des angegebenen Windows auslesen; liefert die Adresse einer
    Kopie der gelesenen Message bzw. NULL, falls keine Message anliegt
    - IDCMP_RAWKEY:
        - Code == eine der F-Tasten:
            Steuerung der Betonungs-Gadgets und NULL-Ergebnis.
        - wd == setupwindow && !spiel_laeuft:
            - Qualifier==0 :
                - CursorUp: Zeilenzahl decrementieren
                - CursorDown: Zeilenzahl incrementieren
                - CursorRight: Spaltenzahl incrementieren
                - CursorLeft: Spaltenzahl decrementieren
            - Qualifier & SHIFT :
                - CursorUp, CursorRight: Fallverzgerung incrementieren
                - CursorDown, CursorLeft: Fallverzgerung decrementieren
            wenn eines davon: NULL-Ergebnis.
    - bei IDCMP_VANILLAKEY und Code==27 (ESC):
        - IDCMPWindow == setupwindow : siehe IDCMP_CLOSEWINDOW
        - IDCMPWindow == window und spiel_laeuft : Kontrollnachfrage
            (Spielabbruch). Bei Besttigung wird abort gesetzt.
            NULL-Ergebnis.
    - bei IDCMP_VANILLAKEY und IDCMPWindow==setupwindow:
        - '1'-'5': Stein-Gruppen 1-5 erlaubt und NULL-Ergebnis
        - 's', 'S': Start=anzahl_erlaubter_steine>0 && !spiel_laeuft;
        - '#': Spielerzahl wechseln 1 <-> 2
        - 'p', 'P': Preview negieren (nicht whrend des Spiels !)
    - bei IDCMP_CLOSEWINDOW: gesicherter Ausstieg, bei Ablehnung:
      NULL-Ergebnis
    - bei IDCMP_REFRESHWINDOW : GT_BeginRefresh() ; GT_EndRefresh();
      NULL-Ergebnis
    - bei Gadget-Anwahl: Einstellung des jeweiligen Parameters:
        - Gadget 0: Spalten
        - Gadget 1: Zeilen
        - Gadget 2: Fallverzgerung
        - Gadget 3: Spielerzahl
        - Gadget 4: Spielstart
        - Gadgets 17-23: Stein-Gruppen 1-7 erlaubt
        - Gadget 5: Preview
      und korrektes, aber eben schon ausgewertetes Ergebnis             */

    static struct IntuiMessage gotten;
    struct IntuiMessage *msg;
    static UBYTE del=10;
    static struct IntuiText
        oktext={2,1,JAM1,6,4,&generalFont,(UBYTE *)"Ja",NULL},
        notext={2,1,JAM1,6,4,&generalFont,(UBYTE *)"Nein",NULL},
        text2={2,1,JAM1,9,13,&generalFont,NULL,NULL},
        text1={2,1,JAM1,9,4,&generalFont,NULL,&text2};
    short y,code;
    USHORT qual;

    if(!(msg=GT_GetIMsg(wd->UserPort))) return(NULL);
    gotten=*msg;    wd=gotten.IDCMPWindow;
    GT_ReplyIMsg(msg);
    if((gotten.Class==IDCMP_VANILLAKEY)&&(gotten.Code==27))
        {
        if(wd==setupwindow)
            gotten.Class=IDCMP_CLOSEWINDOW; /* ESC wird als Abbruch verstanden */
        else if((wd==window)&& spiel_laeuft)
            {
            text1.IText=(UBYTE *)"Wollen   Sie  das";
            text2.IText=(UBYTE *)"Spiel abbrechen ?";
            abort=AutoRequest(wd,&text1,&oktext,&notext,NULL,NULL,210,58);
            return(NULL);
            }
        }
    if((gotten.Class==IDCMP_CLOSEWINDOW)&&(wd==setupwindow))
            {
        text1.IText=(UBYTE *)"Wollen    Sie    das";
        text2.IText=(UBYTE *)"Programm verlassen ?";
        if(AutoRequest(wd,&text1,&oktext,&notext,NULL,NULL,237,58))
            error(NULL);
        return(NULL);
        }
    else if(gotten.Class==IDCMP_INTUITICKS)
        {
        /* schlucken ? */
        if(!spiel_laeuft)   return(NULL);
        if(--del)           return(NULL);
        del=FallDelay;
        }
    else if(gotten.Class==IDCMP_REFRESHWINDOW)
        {
        GT_BeginRefresh(wd);
        SetAPen(wd->RPort,1);
        SetDrMd(wd->RPort,JAM1);
        Move(wd->RPort,126,58);
        Text(wd->RPort,"Steine:",7);
        GT_EndRefresh(wd,TRUE);
        return(NULL);
        }
    else if(gotten.Class==IDCMP_GADGETUP)
        { short gadgetid=((struct Gadget *)msg->IAddress)->GadgetID;
        switch(gadgetid)
            {
            case 0:  if(cols!=msg->Code)
                        {
                        cols=msg->Code;
                        ResizeWindow();
                        }
                     break;
            case 1:  if(rows!=msg->Code)
                        {
                        rows=msg->Code;
                        ResizeWindow();
                        }
                     break;
            case 2:  FallDelay=msg->Code;       break;
            case 3:  zwei_spieler=msg->Code;
                     ResizeWindow();
                     break;
            case 4:  start=TRUE;    break;
            case 5:  preview=!preview;
                     ResizeWindow();
                     GT_SetGadgetAttrs(Gadgets[12],setupwindow,NULL,
                                       GTCB_Checked,preview,TAG_END);
                     break;
            case 17:
            case 18:
            case 19:
            case 20:
            case 21:
            case 22:
            case 23: wechsle_betonung(gadgetid-16,msg->Code);   break;
            }
        if(spiel_laeuft)   ActivateWindow(window);
        }
    else if( (gotten.Class==IDCMP_VANILLAKEY) && (wd==setupwindow) &&
             !spiel_laeuft )
        { /* alle Setup-Window-VANILLAKEY-Kommandos sind im Spiel tot */
        switch(msg->Code)
            {
            case 's':
            case 'S':   start=anzahl_erlaubter_steine>0;    break;
            case 'p':
            case 'P':   preview=!preview;
                        ResizeWindow();
                        GT_SetGadgetAttrs(Gadgets[12],setupwindow,NULL,
                                          GTCB_Checked,preview,TAG_END);
                        break;
            case '#':   zwei_spieler=!zwei_spieler;
                        ResizeWindow();
                        GT_SetGadgetAttrs(Gadgets[3],setupwindow,NULL,
                                          GTCY_Active,zwei_spieler,TAG_END);
                        break;
            }
        }
    else if(gotten.Class==IDCMP_RAWKEY)
        {
        code=msg->Code;
        if((code>0x4f)&&(code<0x55)) /*67*/ /* 2. Bed.: code<0x57 */
            {
            code-=0x4f;
            qual=msg->Qualifier & ~(IEQUALIFIER_RELATIVEMOUSE |
                                    IEQUALIFIER_REPEAT |
                                    IEQUALIFIER_MIDBUTTON |
                                    IEQUALIFIER_RBUTTON |
                                    IEQUALIFIER_LEFTBUTTON)     ;
            switch(qual)
                {
                case 0:
                    if(betonungen[code]<MAXSTRESS)
                        wechsle_betonung(code,betonungen[code]+1);
                    break;
                case IEQUALIFIER_LSHIFT:
                case IEQUALIFIER_RSHIFT:
                    if(betonungen[code]>0)
                        wechsle_betonung(code,betonungen[code]-1);
                    break;
                case IEQUALIFIER_CONTROL:
                    wechsle_betonung(code,0);           break;
                case IEQUALIFIER_LALT:
                case IEQUALIFIER_RALT:
                    wechsle_betonung(code,1);           break;
                case IEQUALIFIER_LCOMMAND:
                case IEQUALIFIER_RCOMMAND:
                    wechsle_betonung(code,MAXSTRESS);   break;
                }
            return(NULL);
            }
        else if((wd==setupwindow) && !spiel_laeuft)
            { /* Steuerung der Gadgets Zeilen, Spalten, Fallverzgerung ? */
            qual=msg->Qualifier & ~(IEQUALIFIER_RELATIVEMOUSE |
                                    IEQUALIFIER_REPEAT |
                                    IEQUALIFIER_MIDBUTTON |
                                    IEQUALIFIER_RBUTTON |
                                    IEQUALIFIER_LEFTBUTTON)     ;
            if(qual & (IEQUALIFIER_LSHIFT | IEQUALIFIER_RSHIFT) )
                { /* mit Shift: Fallverzgerung */
                switch(code)
                    {
                    case 0x4d:
                    case 0x4f:  Dec_FallDelay();    break;
                    case 0x4c:
                    case 0x4e:  Inc_FallDelay();    break;
                    }
                }
            else{ /* ohne Shift: Zeilen / Spalten */
                switch(code)
                    {
                    case 0x4d:  Inc_Zeilen();   break;
                    case 0x4f:  Dec_Spalten();  break;
                    case 0x4c:  Dec_Zeilen();   break;
                    case 0x4e:  Inc_Spalten();  break;
                    }
                }
            }
        }
    return(&gotten);
}

struct IntuiMessage *GetJoy()
{ /* liest den Joystick aus und ergibt im Spiel einen Zeiger auf ein Pseudo-
     IntuiMessage, wenn der Joystick NICHT im Ruhezustand ist.
/*     Falls !spiel_laeuft, wird NULL zurckgegeben, nachdem ggf. folgende
/*     Vernderungen vorgenommen wurden:
/*     - Feuer nicht gedrckt:
/*        - Up: Zeilenzahl incrementieren
/*        - Down: Zeilenzahl decrementieren
/*        - Right: Spaltenzahl incrementieren
/*        - Left: Spaltenzahl decrementieren
/*     - Feuer gedrckt:
/*        - Up, Right: Fallverzgerung incrementieren
/*        - Down, Left: Fallverzgerung decrementieren                      */

    static struct IntuiMessage joy_message={{0},IDCMP_JOY,0,FALSE,
                                            NULL,0,0,0,0,NULL,NULL};
    static UWORD oldqual=FALSE;
    UWORD help;

    if(GetMsg(game_msg_port))
        { /* Daten lesen */
        joy_message.MouseX=gamebuffer.ie_X;
        joy_message.MouseY=gamebuffer.ie_Y;
        if(gamebuffer.ie_Code==IECODE_LBUTTON)
            joy_message.Qualifier=TRUE;
        else if(gamebuffer.ie_Code==IECODE_LBUTTON+IECODE_UP_PREFIX)
            joy_message.Qualifier=FALSE;
        /* Abfrage neu starten */
        game_io_msg->io_Length = sizeof(struct InputEvent);
                /* jeweils EIN Event lesen */
        SendIO(game_io_msg); /* los */
        /* wenn alles wie beim letzten Mal war UND der Feuer-Knopf
           nicht gedrckt : Message schlucken */
        help=oldqual;
        if((oldqual=joy_message.Qualifier) || help ||
           joy_message.MouseX || joy_message.MouseY)
            return(&joy_message);
/*            { /* ggf. Message dekodieren */
/*            if(spiel_laeuft)    return(&joy_message);
/*            if(joy_message.Qualifier)
/*                { /* Fallverzgerung */
/*                switch(joy_message.MouseX)
/*                    {
/*                    case -1:    Dec_FallDelay();    break;
/*                    case 1:     Inc_FallDelay();    break;
/*                    case 0:     switch(joy_message.MouseY)
/*                                    {
/*                                    case -1:    Inc_FallDelay();    break;
/*                                    case 1:     Dec_FallDelay();    break;
/*                                    }
/*                                break;
/*                    }
/*                }
/*            else{ /* Zeilen / Spalten */
/*                switch(joy_message.MouseX)
/*                    {
/*                    case -1:    Dec_Spalten();  break;
/*                    case 1:     Inc_Spalten();  break;
/*                    case 0:     switch(joy_message.MouseY)
/*                                    {
/*                                    case -1:    Inc_Zeilen();   break;
/*                                    case 1:     Dec_Zeilen();   break;
/*                                    }
/*                                break;
/*                    }
/*                }
/*            } */
        }
    return(NULL);
}

struct IntuiMessage *WaitMessage()
{/* ggf. auf eine Message warten, diese lesen; liefert die Adresse einer Kopie
    der gelesenen Message.      */
    struct IntuiMessage *msg;
    ULONG Signals;

    Signals=(1<<window->UserPort->mp_SigBit)|
            (1<<setupwindow->UserPort->mp_SigBit)|
            (1<<game_msg_port->mp_SigBit);
Wait:
    if(msg=GetMessage(window))      return(msg);
    if(msg=GetMessage(setupwindow)) return(msg);
    if(msg=GetJoy())                return(msg);
    Wait(Signals);
    goto Wait;
}

BOOL outside(BYTE x, BYTE y)
{ /* ermittelt, ob x/y auerhalb des Spielfeldes liegt */

    if(x<0)     return(TRUE);
    if(x>=cols) return(TRUE);
    if(y<0)     return(TRUE);
    if(y>=rows) return(TRUE);
    return(FALSE);
}

BOOL included(struct Stein *stein, BYTE x, BYTE y)
{ /* ermittelt, ob x/y vom Stein *stein (auf absolute Koordinaten
     umgerechnet !) bedeckt wird */
    BYTE cnt;

    if((x==stein->MitteX)&&(y==stein->MitteY))  return(TRUE);
    for(cnt=0;cnt<stein->Teile;++cnt)
        if((x==stein->OffsetX[cnt])&&(y==stein->OffsetY[cnt]))
            return(TRUE);
    return(FALSE);
}

BYTE collide(struct Stein *stein, BYTE spieler)
{ /* ermittelt, ob der angegebene Stein fr den angegebenen Spieler nicht
     existieren kann (die Spielenummer wird gebraucht, da
     aktueller_stein[spieler] im Gegensatz zu aktueller_stein[1-spieler]
     nicht zur Kollision herangezogen werden darf - es wird im Regelfall
     darum gehen, ob eine (noch nicht eingesetzte) Position erlaubt ist.
     Ergebnis:
     0 - keine Kollision
     1 - Kollision mit fest bestehenden Steinen / Lage auerhalb Spielfeld
     2 - Kollision mit anderem Spielstein
     Aus einem Ergebnis 1 folgt NICHT, da der Stein sich nicht mit dem des
     Mitspielers berdeckt !                                            */

    BYTE x,y,cnt;
    struct Stein anderer_stein;

    x=stein->MitteX;
    y=stein->MitteY;
    if(outside(x,y))    return(1);
    if(Spielfeld[x][y]) return(1);
    for(cnt=0;cnt<stein->Teile;++cnt)
        {
        if(outside(x+stein->OffsetX[cnt],y+stein->OffsetY[cnt]))
            return(1);
        if(Spielfeld[x+stein->OffsetX[cnt]][y+stein->OffsetY[cnt]])
            return(1);
        }
    if(zwei_spieler)
        { /* Kollision mit anderem Stein ? */
        anderer_stein=aktueller_stein[1-spieler];
        /* Umrechnung auf absolute Koordinaten */
        x=anderer_stein.MitteX;
        y=anderer_stein.MitteY;
        for(cnt=0;cnt<stein->Teile;++cnt)
            {
            anderer_stein.OffsetX[cnt]+=x;
            anderer_stein.OffsetY[cnt]+=y;
            }
        /* eigentliche Kontrollen */
        if(included(&anderer_stein,x=stein->MitteX,y=stein->MitteY))
            return(2);
        for(cnt=0;cnt<stein->Teile;++cnt)
            if(included(&anderer_stein,x+stein->OffsetX[cnt],
                                       y+stein->OffsetY[cnt]))
                return(2);
        }
    return(0);
}

BYTE Step(BYTE spieler, BYTE dx, BYTE dy)
{ /* bewegt den Stein nach Mglichkeit.
     Ergebnis:
     0 - keine Kollision
     1 - Kollision mit fest bestehenden Steinen / Lage auerhalb Spielfeld
     2 - Kollision mit anderem Spielstein
     Aus einem Ergebnis 1 folgt NICHT, da der Stein sich nicht mit dem des
     Mitspielers berdeckt !                                            */

    BYTE impossible;
    struct Stein *stein;

    stein=aktueller_stein+spieler;
    stein->MitteX+=dx;  stein->MitteY+=dy;
    impossible=collide(stein,spieler);
    stein->MitteX-=dx;  stein->MitteY-=dy;
    if(impossible)  return(impossible);
    ZeichneStein(stein,0);
    stein->MitteX+=dx;  stein->MitteY+=dy;
    ZeichneStein(stein,spieler+1);
    return(0);
}

#define Down(spieler) Step(spieler,0,1)
    /* bewegt den Stein nach Mglichkeit ein Feld abwrts.
       Returniert wird, ob's und weswegen es nicht ging. (^Step) */
#define Left(spieler) Step(spieler,-1,0)
    /* bewegt den Stein nach Mglichkeit ein Feld nach links. */
#define Right(spieler) Step(spieler,1,0)
    /* bewegt den Stein nach Mglichkeit ein Feld nach rechts. */

VOID Turn(BYTE spieler)
{ /* den Stein des angegebenen Spielers wenn mglich drehen */
    UBYTE cnt,help;
    struct Stein old,*stein;

    stein=aktueller_stein+spieler;
    old=*stein;
    do  {
        /* Drehen */
        for(cnt=0;cnt<stein->Teile;++cnt)
            { /* ein Element drehen */
            help=stein->OffsetY[cnt];
            stein->OffsetY[cnt]=stein->OffsetX[cnt];
            stein->OffsetX[cnt]=-help;
            }
        } while(collide(stein,spieler));
            /* sptestens nach dem 4. Drehen bricht die Schleife ab: dann
               ist der Status Quo erreicht !                              */
    ZeichneStein(&old,0);
    ZeichneStein(stein,spieler+1);
}

VOID Mirror(BYTE spieler)
{ /* den Stein des angegebenen Spielers wenn mglich senkrecht spiegeln */
    UBYTE cnt;
    struct Stein new,*stein;

    stein=aktueller_stein+spieler;
    new=*stein;
    for(cnt=0;cnt<stein->Teile;++cnt)   new.OffsetX[cnt]=-new.OffsetX[cnt];
    if(!collide(&new,spieler))
        {
        ZeichneStein(stein,0);
        *stein=new;
        ZeichneStein(stein,spieler+1);
        }
}

VOID Setzen(BYTE spieler)
{ /* setzt den aktuellen_stein des angegebenen Spielers fest in das
     Spielfeld ein und handhabt alle Eventualitten, inklusive Scoring. */

    struct Stein *stein;
    BYTE x,y,cnt;

    stein=aktueller_stein+spieler;
    x=stein->MitteX;
    y=stein->MitteY;
    Spielfeld[x][y]=spieler+1;
    ++Steine_Pro_Zeile[y];
    for(cnt=0;cnt<stein->Teile;++cnt)
        {
        Spielfeld[x+stein->OffsetX[cnt]][y+stein->OffsetY[cnt]]=spieler+1;
        ++Steine_Pro_Zeile[y+stein->OffsetY[cnt]];
        }

    /* Reihen berprfen */
    for(cnt=0;cnt<rows;++cnt)
        if(Steine_Pro_Zeile[cnt]==cols)
            { /* Zeile einschmelzen */
            /* darberliegende Zeilen runterholen */
            ++abgesenkte_zeilen;
            for(y=cnt-1;y>=0;--y)
                {
                for(x=0;x<cols;++x)
                    ZeichneSteinchen(Spielfeld[x][y+1]=Spielfeld[x][y],x,y+1);
                Steine_Pro_Zeile[y+1]=Steine_Pro_Zeile[y];
                }
            /* oberste Zeile lschen */
            for(x=0;x<cols;++x)
                ZeichneSteinchen(Spielfeld[x][0]=0,x,0);
            Steine_Pro_Zeile[0]=0;
            if(!collided[1-spieler] && zwei_spieler)
                ZeichneStein(aktueller_stein+1-spieler,2-spieler);
            }

    ++abgesetzte_steine[spieler];
    Scoring();
}

VOID Absetzen(BYTE spieler)
{ /* den aktuellen_stein des genannten Spielers absenken, soweit mglich */
    BYTE help;

    while((help=Down(spieler))==0)  Delay(2);
    if(collided[spieler]=(help==1)) Setzen(spieler);
}

VOID Pause()
{ /* Pause durchfhren */
    static struct NewWindow pnw={0,0,240,11,-1,-1,
                                IDCMP_CLOSEWINDOW|IDCMP_RAWKEY|IDCMP_MOUSEBUTTONS,
                                WFLG_ACTIVATE|WFLG_SMART_REFRESH|WFLG_RMBTRAP|WFLG_DRAGBAR|WFLG_DEPTHGADGET|WFLG_CLOSEGADGET,
                                NULL,NULL,(UBYTE *)"Hybris V1.3 - Pause",
                                NULL,NULL,5,5,640,256,WBENCHSCREEN};
    ULONG Signals;

    pnw.TopEdge=window->TopEdge+(window->Height-pnw.Height)/2;
    pnw.LeftEdge=window->LeftEdge+(window->Width-pnw.Width)/2;
    if(pnw.LeftEdge<0)  pnw.LeftEdge=0;
    pnw.Screen=window->WScreen;
    if(!(pausewindow=OpenWindow(&pnw))) return; /* kein Window zu haben */
    ScratchMsgQueue(window->UserPort);
    ScratchMsgQueue(setupwindow->UserPort);
    /* (mglichst) die RAWKEY-KeyUp-Message bei Tastatur-Pause abfangen */
    Delay(10);  ScratchMsgQueue(pausewindow->UserPort);
    while(GetJoy());
    Signals=(1<<pausewindow->UserPort->mp_SigBit)|
            (1<<setupwindow->UserPort->mp_SigBit)|
            (1<<game_msg_port->mp_SigBit);
    do  {
        /* ggf. Refresh durchfhren lassen */
        while(GetMessage(setupwindow));
        /* bei relevanten Messages Abbruch der Pause */
        if(GetMessage(pausewindow)) break;
        if(GetJoy())                break;
        Wait(Signals);
        } while(TRUE);
    Forbid();
    ScratchMsgQueue(pausewindow->UserPort);
    CloseWindow(pausewindow);
    pausewindow=NULL;
    Permit();
    ScratchMsgQueue(window->UserPort);
    ScratchMsgQueue(setupwindow->UserPort);
    while(GetJoy());
}

VOID main()
{
    struct IntuiMessage *msg;
    BYTE x,y;
    short cnt;

    rows=20;
    cols=11;
    preview=spiel_laeuft=zwei_spieler=FALSE;
    FallDelay=3;
    for(cnt=1;cnt<8;++cnt)  betonungen[cnt]=0;
    init();
    wechsle_betonung(4,1);

    while(TRUE)
        {
        /* neues Spiel vorbereiten */
        spiel_laeuft=FALSE;
        start=FALSE;
        ActivateWindow(setupwindow);
        WindowToFront(setupwindow);
        GT_SetGadgetAttrsA(Gadgets[0],setupwindow,NULL,TAGA_ENABLE);
        GT_SetGadgetAttrsA(Gadgets[1],setupwindow,NULL,TAGA_ENABLE);
        GT_SetGadgetAttrsA(Gadgets[3],setupwindow,NULL,TAGA_ENABLE);
        if(anzahl_erlaubter_steine)
            GT_SetGadgetAttrsA(Gadgets[4],setupwindow,NULL,TAGA_ENABLE);
        GT_SetGadgetAttrsA(Gadgets[12],setupwindow,NULL,TAGA_ENABLE);
        while(!start)
            {
            msg=WaitMessage();
            if(msg->Class==IDCMP_JOY)   start=(BOOL)msg->Qualifier;
            }
        GT_SetGadgetAttrsA(Gadgets[0],setupwindow,NULL,TAGA_DISABLE);
        GT_SetGadgetAttrsA(Gadgets[1],setupwindow,NULL,TAGA_DISABLE);
        GT_SetGadgetAttrsA(Gadgets[3],setupwindow,NULL,TAGA_DISABLE);
        GT_SetGadgetAttrsA(Gadgets[4],setupwindow,NULL,TAGA_DISABLE);
        GT_SetGadgetAttrsA(Gadgets[12],setupwindow,NULL,TAGA_DISABLE);
        ClearGamblingArea();
        for(y=0;y<rows;++y)
            {
            for(x=0;x<cols;++x)     Spielfeld[x][y]=0;
            Steine_Pro_Zeile[y]=0;
            }
        abgesetzte_steine[0]=abgesetzte_steine[1]=abgesenkte_zeilen=0;
        Scoring();
        spiel_laeuft=TRUE;
        abort=FALSE;
        ActivateWindow(window);
        WindowToFront(window);

        /* erste Steine anmahnen: */
        collided[0]=TRUE;
        collided[1]=zwei_spieler;   /* 2. Spieler kriegt nur einen Stein,
                                       wenn er berhaupt mitspielt */
        while(!abort)
            {
            if(collided[0])
                { /* Stein fr Spieler 1 ins Spiel bringen */
                aktueller_stein[0]=naechster_stein[0];
                Preview(0);
                /* Steine[erlaubte_steine[
                                          RangeRand(anzahl_erlaubter_steine)
                                         ] ]; */
                /*if(zwei_spieler)    aktueller_stein[0].MitteX-=2;*/
                if(!(collided[0]=collide(aktueller_stein,0)))
                    ZeichneStein(aktueller_stein,1);
                }
            if(collided[1] && zwei_spieler)
                { /* Stein fr Spieler 2 ins Spiel bringen */
                aktueller_stein[1]=naechster_stein[1];
                Preview(1);
                /* Steine[erlaubte_steine[
                                          RangeRand(anzahl_erlaubter_steine)
                                         ] ]; */
                /*aktueller_stein[1].MitteX+=2;*/
                if(!(collided[1]=collide(aktueller_stein+1,1)))
                    ZeichneStein(aktueller_stein+1,2);
                }
            abort=collided[0] && (collided[1] || !zwei_spieler);
            msg=WaitMessage();
            switch(msg->Class)
                {
                case IDCMP_INTUITICKS:
                    for(cnt=0;cnt<=zwei_spieler;++cnt)
                        if(!collided[cnt])
                            if(collided[cnt]=(Down(cnt)==1))    Setzen(cnt);
                    break;
                case IDCMP_JOY:
                    if(msg->Qualifier)
                        Turn(0);
                    else if(msg->MouseY==0)
                        {
                        if(msg->MouseX)
                            Step(0,msg->MouseX,0);
                        }
                    else if(msg->MouseX==0)
                        {
                        if(msg->MouseY>0)
                            {
                            Absetzen(0);
                            /* gepufferte Kommandos lschen */
                            while(GetJoy());
                            }
                        else if(msg->MouseY<0)
                            Pause();
                        }
                    break;
                case IDCMP_VANILLAKEY:
                    if(msg->IDCMPWindow==window)
                        switch(msg->Code)
                            {
                            case '2':   /* runter */
                                        Absetzen(zwei_spieler);
                                        /* gepufferte Kommandos lschen */
                                        ScratchMsgQueue(window->UserPort);
                                        break;
                            case '6':   /* rechts */
                                        Right(zwei_spieler);    break;
                            case '4':   /* links */
                                        Left(zwei_spieler);     break;
                            case 'p':
                            case 'P':
                            case '8':   Pause();                break;
                            case ' ':
                            case '5':
                            case 10:    /* LF */
                            case 13:    /* CR */
                                        Turn(zwei_spieler);     break;
                            case 'm':
                            case 'M':   Mirror(zwei_spieler);   break;
                            }
                    break;
                case IDCMP_RAWKEY:
                    switch(msg->Code)
                        {
                        case 0x4d: /* runter */
                            Absetzen(zwei_spieler);
                            /* gepufferte Kommandos lschen */
                            ScratchMsgQueue(window->UserPort);
                            break;
                        case 0x4e:  /* rechts */
                                    Right(zwei_spieler);
                                    break;
                        case 0x4f:  /* links */
                                    Left(zwei_spieler);
                                    break;
                        case 0x4c:  /* rauf */
                        case 0x5f:  Pause();
                                    break;
                        }
                    break;
                }
            }
        ScratchMsgQueue(window->UserPort);
        spiel_laeuft=FALSE;
        }
}

void wbmain(struct WBStartup *wbarg)
{ main(); }
